# PASLIBP.MAK : Compile all Pascal library .TPP (protected mode) units
# ---------------------------------------------------------------------
# Date    : Nov 08,1996
# Author  : J R Ferguson
# Language: Borland Make utility / Borland Pascal v7.0
# Target  : MS-DOS Protected mode
# Usage   : MAKE -fPASLIBP.MAK
# ---------------------------------------------------------------------
#
# ==> Use TASM v1.0 (not v3.2) for STPLIB1.ASM to avoid far call problem
#
# compiler options
#
opt1=/$B- /$D- /$L- /$Q- /$R- /$S- /$V-
opt2=/E.. /Tc:\bp\bin /U.. /I.. /Q

#
# implicit rules
#
.pas.tpp:
 bpc -CP $* $(opt1) $(opt2)

.asm.obj:
 tasm10 $*

#
# force evaluation of all dependencies
#
dummy: ARGLIB.TPP  \
       BPVLIB.TPP  \
       CHRLIB.TPP  \
       CONLIB.TPP  \
       CVTLIB.TPP  \
       DBGLIB.TPP  \
       DEFLIB.TPP  \
       DIRLIB.TPP  \
       DMPLIB.TPP  \
       DTMLIB.TPP  \
       EVLLIB.TPP  \
       FLTLIB.TPP  \
       MATIO.TPP   \
       MATLIB.TPP  \
       NIOLIB.TPP  \
       NUMLIB.TPP  \
       OBJLIB.TPP  \
       OBTLIB.TPP  \
       OPOLIB.TPP  \
       OPTLIB.TPP  \
       RNGLIB.TPP  \
       RRGLIB.TPP  \
       RTSLIB.TPP  \
       SCKLIB.TPP  \
       SLLLIB.TPP  \
       STFLIB.TPP  \
       STPLIB.TPP  \
       STZLIB.TPP  \
       SRTLIB.TPP  \
       TIMLIB.TPP  \
       VIDLIB.TPP

#
# dependencies
#
ARGLIB.TPP:  ARGLIB.PAS  CHRLIB.TPP
BPVLIB.TPP:  BPVLIB.PAS
CHRLIB.TPP:  CHRLIB.PAS
CONLIB.TPP:  CONLIB.PAS  DEFLIB.TPP
CVTLIB.TPP:  CVTLIB.PAS  DEFLIB.TPP CHRLIB.TPP
DBGLIB.TPP:  DBGLIB.PAS  DEFLIB.TPP CONLIB.TPP
DEFLIB.TPP:  DEFLIB.PAS
DIRLIB.TPP:  DIRLIB.PAS  DEFLIB.TPP
DMPLIB.TPP:  DMPLIB.PAS
DTMLIB.TPP:  DTMLIB.PAS
EVLLIB.TPP:  EVLLIB.PAS  DEFLIB.TPP
FLTLIB.TPP:  FLTLIB.PAS  DEFLIB.TPP OPOLIB.TPP RNGLIB.TPP
MATIO.TPP:   MATIO.PAS   DEFLIB.TPP MATLIB.TPP
MATLIB.TPP:  MATLIB.PAS  
NIOLIB.TPP:  NIOLIB.PAS  DEFLIB.TPP CVTLIB.TPP
NUMLIB.TPP:  NUMLIB.PAS
OBJLIB.TPP:  OBJLIB.PAS
OBTLIB.TPP:  OBTLIB.PAS  OBJLIB.TPP
OPOLIB.TPP:  OPOLIB.PAS  OPTLIB.TPP DEFLIB.TPP RNGLIB.TPP
OPTLIB.TPP:  OPTLIB.PAS  ARGLIB.TPP CHRLIB.TPP STPLIB.TPP RNGLIB.TPP
RNGLIB.TPP:  RNGLIB.PAS
RRGLIB.TPP:  RRGLIB.PAS  DEFLIB.TPP
RTSLIB.TPP:  RTSLIB.PAS  DEFLIB.TPP
SCKLIB.TPP:  SCKLIB.PAS  DEFLIB.TPP CHRLIB.TPP
SLLLIB.TPP:  SLLLIB.PAS  OBJLIB.TPP
SRTLIB.TPP:  SRTLIB.PAS
STFLIB.TPP:  STFLIB.PAS  DEFLIB.TPP STPLIB.TPP
STPLIB.TPP:  STPLIB.PAS  STPLIB1.OBJ DEFLIB.TPP CHRLIB.TPP
STPLIB1.OBJ: STPLIB1.ASM
STZLIB.TPP:  STZLIB.PAS  DEFLIB.TPP CHRLIB.TPP
TIMLIB.TPP:  TIMLIB.PAS  DTMLIB.TPP
VIDL86.OBJ:  VIDL86.ASM
VIDL86P.OBJ: VIDL86P.ASM
VIDLIB.TPP:  VIDLIB.PAS  VIDL86.OBJ VIDL86P.OBJ
